Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.hsqldb.jdbc
Class JDBCPool

    java.lang.Object
      org.hsqldb.jdbc.JDBCCommonDataSource
          org.hsqldb.jdbc.JDBCPool

All Implemented Interfaces:
  Serializable, Wrapper, EventListener, Referenceable, CommonDataSource, ConnectionEventListener, DataSource, StatementEventListener

    public class JDBCPool

extends JDBCCommonDataSource
implements DataSource, Serializable, Referenceable, ConnectionEventListener, StatementEventListener, Wrapper

### HSQLDB-Specific Information:

A connection pool for HyperSQL connections. This implementation of `DataSource` is dedicated to HyperSQL and guarantees all connection states are automatically reset when a connection is reused.

The methods of the parent class, `JDBCCommonDataSource` are used to specify the database URL, user, password, and / or connection properties.

Since:
  2.2.9
Author:
  Fred Toussi (fredt@users dot sourceforge.net)
See Also:
  Serialized Form

Constructor Summary
`JDBCPool()` Creates a connection pool with the maximum size of 8.
`JDBCPool(int size)` Creates a connection pool with the given maximum size.

Method Summary
`void` | `close(int wait)` Closes the pool immediately.
`void` | `connectionClosed(ConnectionEvent event)`
`void` | `connectionErrorOccurred(ConnectionEvent event)`
`Connection` | `getConnection()` Retrieves a new connection using the properties that have already been set.
`Connection` | `getConnection(String username, String password)` Retrieves a new connection using the given username and password, and the database url that has been set.
`String` | `getDatabase()` Synonym for getUrl().
`String` | `getDatabaseName()` Synonym for getUrl().
`String` | `getDataSourceName()` Retrieves the name of the data source.
`String` | `getDescription()` Retrieves the description of the data source.
`int` | `getLoginTimeout()` Gets the maximum time in seconds that this data source can wait while attempting to connect to a database.
`PrintWriter` | `getLogWriter()` Retrieves the log writer for this `DataSource` object.
`Logger` | `getParentLogger()` Return the parent Logger of all the Loggers used by this data source.
`Reference` | `getReference()` Retrieves the Reference of this object.
`String` | `getUrl()` Retrieves the jdbc database connection url attribute.
`String` | `getUser()` Retrieves the user name for the connection.
`boolean` | `isWrapperFor(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`void` | `setDatabase(String database)` Synonym for setUrl(String).
`void` | `setDatabaseName(String databaseName)` Synonym for setUrl(String).
`void` | `setLoginTimeout(int seconds)` Sets the maximum time in seconds that this data source will wait while attempting to connect to a database.
`void` | `setLogWriter(PrintWriter out)` Sets the log writer for this `DataSource` object to the given `java.io.PrintWriter` object.
`void` | `setPassword(String password)` Sets the password for the user name.
`void` | `setProperties(Properties props)` Sets connection properties.
`void` | `setUrl(String url)` Sets the jdbc database URL.
`void` | `setUser(String user)` Sets the user name.
`void` | `statementClosed(StatementEvent event)`
`void` | `statementErrorOccurred(StatementEvent event)`
`
`<T> T`
` | `unwrap(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.

Methods inherited from class org.hsqldb.jdbc.JDBCCommonDataSource
`getNetworkProtocol, getServerName, setURL`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JDBCPool

    public JDBCPool()

  Creates a connection pool with the maximum size of 8. The database and connection settings are made before the `getConnection()` is called.

### JDBCPool

    public JDBCPool(int size)

  Creates a connection pool with the given maximum size. The database and connection settings are made before the `getConnection()` is called.

  Parameters:
    `size` - int maximum size of the pool

Method Detail

### getConnection

    public Connection getConnection()
                             throws SQLException

  Retrieves a new connection using the properties that have already been set.

  Specified by:
    `getConnection` in interface `DataSource`
  Returns:
    a connection to the data source
  Throws:
    `SQLException` - if a database access error occurs

### getConnection

    public Connection getConnection(String username,
                                    String password)
                             throws SQLException

  Retrieves a new connection using the given username and password, and the database url that has been set. No other properties are used for the connection

  Specified by:
    `getConnection` in interface `DataSource`
  Parameters:
    `username` - the database user on whose behalf the connection is being made
    `password` - the user's password
  Returns:
    a connection to the data source
  Throws:
    `SQLException` - if a database access error occurs

### unwrap

    public <T> T unwrap(Class<T> iface)
             throws SQLException

  Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

  Specified by:
    `unwrap` in interface `Wrapper`
  Parameters:
    `iface` - A Class defining an interface that the result must implement.
  Returns:
    an object that implements the interface. May be a proxy for the actual implementing object.
  Throws:
    `SQLException` - If no object found that implements the interface
  Since:
    JDK 1.6, HSQLDB 2.0

### isWrapperFor

    public boolean isWrapperFor(Class<?> iface)
                         throws SQLException

  Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

  Specified by:
    `isWrapperFor` in interface `Wrapper`
  Parameters:
    `iface` - a Class defining an interface.
  Returns:
    true if this implements the interface or directly or indirectly wraps an object that does.
  Throws:
    `SQLException` - if an error occurs while determining whether this is a wrapper for an object with the given interface.
  Since:
    JDK 1.6, HSQLDB 2.0

### getReference

    public Reference getReference()
                           throws NamingException

  Retrieves the Reference of this object.

  Specified by:
    `getReference` in interface `Referenceable`
  Returns:
    The non-null Reference of this object.
  Throws:
    `NamingException` - If a naming exception was encountered while retrieving the reference.

### connectionClosed

    public void connectionClosed(ConnectionEvent event)

  Specified by:
    `connectionClosed` in interface `ConnectionEventListener`

### connectionErrorOccurred

    public void connectionErrorOccurred(ConnectionEvent event)

  Specified by:
    `connectionErrorOccurred` in interface `ConnectionEventListener`

### statementClosed

    public void statementClosed(StatementEvent event)

  Specified by:
    `statementClosed` in interface `StatementEventListener`

### statementErrorOccurred

    public void statementErrorOccurred(StatementEvent event)

  Specified by:
    `statementErrorOccurred` in interface `StatementEventListener`

### getLogWriter

    public PrintWriter getLogWriter()
                             throws SQLException

  Retrieves the log writer for this `DataSource` object.

  The log writer is a character output stream to which all logging and tracing messages for this data source will be printed. This includes messages printed by the methods of this object, messages printed by methods of other objects manufactured by this object, and so on. Messages printed to a data source specific log writer are not printed to the log writer associated with the `java.sql.DriverManager` class. When a `DataSource` object is created, the log writer is initially null; in other words, the default is for logging to be disabled.

  Specified by:
    `getLogWriter` in interface `CommonDataSource`
  Overrides:
    `getLogWriter` in class `JDBCCommonDataSource`
  Returns:
    the log writer for this data source or null if logging is disabled
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4
  See Also:
    `setLogWriter(java.io.PrintWriter)`

### setLogWriter

    public void setLogWriter(PrintWriter out)
                      throws SQLException

  Sets the log writer for this `DataSource` object to the given `java.io.PrintWriter` object.

  The log writer is a character output stream to which all logging and tracing messages for this data source will be printed. This includes messages printed by the methods of this object, messages printed by methods of other objects manufactured by this object, and so on. Messages printed to a data source- specific log writer are not printed to the log writer associated with the `java.sql.DriverManager` class. When a `DataSource` object is created the log writer is initially null; in other words, the default is for logging to be disabled.

  Specified by:
    `setLogWriter` in interface `CommonDataSource`
  Overrides:
    `setLogWriter` in class `JDBCCommonDataSource`
  Parameters:
    `out` - the new log writer; to disable logging, set to null
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.4
  See Also:
    `getLogWriter()`

### setLoginTimeout

    public void setLoginTimeout(int seconds)
                         throws SQLException

  Sets the maximum time in seconds that this data source will wait while attempting to connect to a database. A value of zero specifies that the timeout is the default system timeout if there is one; otherwise, it specifies that there is no timeout. When a `DataSource` object is created, the login timeout is initially zero.

  Specified by:
    `setLoginTimeout` in interface `CommonDataSource`
  Overrides:
    `setLoginTimeout` in class `JDBCCommonDataSource`
  Parameters:
    `seconds` - the data source login time limit
  Throws:
    `SQLException` - if a database access error occurs.
  Since:
    1.4
  See Also:
    `getLoginTimeout()`

### getLoginTimeout

    public int getLoginTimeout()
                        throws SQLException

  Gets the maximum time in seconds that this data source can wait while attempting to connect to a database. A value of zero means that the timeout is the default system timeout if there is one; otherwise, it means that there is no timeout. When a `DataSource` object is created, the login timeout is initially zero.

  Specified by:
    `getLoginTimeout` in interface `CommonDataSource`
  Overrides:
    `getLoginTimeout` in class `JDBCCommonDataSource`
  Returns:
    the data source login time limit
  Throws:
    `SQLException` - if a database access error occurs.
  Since:
    1.4
  See Also:
    `setLoginTimeout(int)`

### getDescription

    public String getDescription()

  Retrieves the description of the data source.

  Overrides:
    `getDescription` in class `JDBCCommonDataSource`
  Returns:
    the description

### getDataSourceName

    public String getDataSourceName()

  Retrieves the name of the data source.

  Overrides:
    `getDataSourceName` in class `JDBCCommonDataSource`
  Returns:
    the description

### getDatabaseName

    public String getDatabaseName()

  Synonym for getUrl().

  Overrides:
    `getDatabaseName` in class `JDBCCommonDataSource`
  Returns:
    the jdbc database connection url attribute

### getDatabase

    public String getDatabase()

  Synonym for getUrl().

  Overrides:
    `getDatabase` in class `JDBCCommonDataSource`
  Returns:
    the jdbc database connection url attribute

### getUrl

    public String getUrl()

  Retrieves the jdbc database connection url attribute.

  Overrides:
    `getUrl` in class `JDBCCommonDataSource`
  Returns:
    the jdbc database connection url attribute

### getUser

    public String getUser()

  Retrieves the user name for the connection.

  Overrides:
    `getUser` in class `JDBCCommonDataSource`
  Returns:
    the username for the connection

### setDatabaseName

    public void setDatabaseName(String databaseName)

  Synonym for setUrl(String).

  Overrides:
    `setDatabaseName` in class `JDBCCommonDataSource`
  Parameters:
    `databaseName` - the new value for the attribute

### setDatabase

    public void setDatabase(String database)

  Synonym for setUrl(String).

  Overrides:
    `setDatabase` in class `JDBCCommonDataSource`
  Parameters:
    `database` - the new value for the attribute

### setUrl

    public void setUrl(String url)

  Sets the jdbc database URL.

  Overrides:
    `setUrl` in class `JDBCCommonDataSource`
  Parameters:
    `url` - the new value of this object's jdbc database connection url attribute

### setPassword

    public void setPassword(String password)

  Sets the password for the user name.

  Overrides:
    `setPassword` in class `JDBCCommonDataSource`
  Parameters:
    `password` - the password

### setUser

    public void setUser(String user)

  Sets the user name.

  Overrides:
    `setUser` in class `JDBCCommonDataSource`
  Parameters:
    `user` - the user id

### setProperties

    public void setProperties(Properties props)

  Sets connection properties. If user / password / logginTimeout has been set with one of the setXXX() methods it will be added to the Properties object.

  Overrides:
    `setProperties` in class `JDBCCommonDataSource`
  Parameters:
    `props` - properties. If null, then existing properties will be cleared/replaced.

### getParentLogger

    public Logger getParentLogger()
                           throws SQLFeatureNotSupportedException

  Return the parent Logger of all the Loggers used by this data source. This should be the Logger farthest from the root Logger that is still an ancestor of all of the Loggers used by this data source. Configuring this Logger will affect all of the log messages generated by the data source. In the worst case, this may be the root Logger.

  Overrides:
    `getParentLogger` in class `JDBCCommonDataSource`
  Returns:
    the parent Logger for this data source
  Throws:
    `SQLFeatureNotSupportedException` - if the data source does not use `java.util.logging`.``
  Since:
    JDK 1.7 M11 2010/09/10 (b123), HSQLDB 2.2.9

### close

    public void close(int wait)
               throws SQLException

  Closes the pool immediately. Waits the given number of seconds before closing all existing connections in the pool.

  Parameters:
    `wait` - int number of seconds to wait before closing the connections, maximum 60 seconds
  Throws:
    `SQLException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001 - 2013 HSQL Development Group.